/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.account.length < 6) {
			return callback('账号最短为 5 个字符');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		//登录验证
		return loginajax(loginInfo, callback);
	};
	//获取客户端推送标识
	function getPushInfo() {
		var info = plus.push.getClientInfo();
		alert("获取客户端推送标识信息：");
		alert("token: " + info.token);
		alert("clientid: " + info.clientid);
		alert("appid: " + info.appid);
		alert("appkey: " + info.appkey);
	}
	//本地验证用户（没用到）
	var loginlocal = function(loginInfo, callback) {
			//获取用户信息（本地）
			var users = JSON.parse(localStorage.getItem('$dsyz_users') || '[]');
		//	alert(localStorage.getItem('$dsyz_users') );
			//比较输入和本地存储的登录信息
			//JavaScript数组some()方法测试数组中的某个元素是否通过由提供的功能来实现测试
			var authed = users.some(function(user) {
				return loginInfo.account == user.account && loginInfo.password == user.password;
			});
			//结果处理
			if (authed) {
				return owner.createState(loginInfo.account, callback);
			} else {
				return callback('用户名或密码错误');
			}
		}
	//登录服务端
	var loginajax = function(loginInfo, callback) {
			plus.nativeUI.showWaiting("登录中......");
			$.ajax(baseUrl + '/mobile/doLoginSJByMobile.do', {
				data: {
					rybh: loginInfo.account, //人员编号
					mm: loginInfo.password //密码
				},
				dataType: 'json', //服务器返回json格式数据
				type: 'post', //HTTP请求类型
				timeout: 10000, //超时时间设置为10秒；
				success: function(data) {
					plus.nativeUI.closeWaiting();
					
					localStorage.setItem('sfpassword', "");
					//登录服务端验证结果
					if (data.result == '0') {
						//alert(data.resultMsg);
						return callback(data.resultMsg);
					}
					if (data.result == '1') {
						//附加服务端返回数据
						//mui.extend(loginInfo, data.user);
						var userLocal={'loginInfo':loginInfo,'user':data.user};
						//alert(JSON.stringify(userLocal));
						//将登录信息注册到本地
						return setuserlocal(userLocal, callback);
					}
				},
				error: function(xhr, type, errorThrown) {
					//异常处理；
					plus.nativeUI.closeWaiting();
					 plus.nativeUI.toast("服务器故障，请查看是否打开网络连接，如再次进入仍然看到此信息请联系平台服务人员！");
					console.log(type);
				}
			});
		}
	//登录成功创建token
	owner.createState = function(name, callback) {
		var state = owner.getState();
		state.account = name;
		state.token = getToken();
		owner.setState(state);
		return callback();
	};
	//获取自动登录令牌
	function getToken() {
		var info = plus.push.getClientInfo();
		//alert("token: " + info.token);
		return info.token;
	}
	//将登录信息，用户信息保存到本地
	var setuserlocal = function(userLocal, callback) {
			var users = [];//登录信息的数组
			users.push(userLocal);//将该用户的登录信息添加到数组
			localStorage.setItem('$dsyz_users', JSON.stringify(users));
			var settings = owner.getSettings();
			if(settings.autoLogin){
				//如果选择自动登录，创建令牌
				return owner.createState(userLocal.loginInfo.account, callback);
			}
			return callback();//
		}
		/**
		 * 新用户注册
		 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.account = regInfo.account || '';
		regInfo.password = regInfo.password || '';
		if (regInfo.account.length < 5) {
			return callback('用户名最短需要 5 个字符');
		}
		if (regInfo.password.length < 6) {
			return callback('密码最短需要 6 个字符');
		}
		if (!checkEmail(regInfo.email)) {
			return callback('邮箱地址不合法');
		}
		//将注册信息注册到本地
		var users = JSON.parse(localStorage.getItem('$dsyz_users') || '[]');
		users=[];
		users.push('user',regInfo);
		localStorage.setItem('$dsyz_users', JSON.stringify(users));
		return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		var settings = owner.getSettings();
		settings.gestures = '';
		owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
		 
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
}(mui, window.app = {}));